%{!?perl_archlib:    %define perl_archlib    %(eval "`%{__perl} -V:installarchlib`"   ; echo $installarchlib)}
%{!?perl_vendorlib:  %define perl_vendorlib  %(eval "`%{__perl} -V:installvendorlib`" ; echo $installvendorlib)}
%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%{!?perl_version:    %define perl_version    %(eval "`%{__perl} -V:version`"          ; echo $version)}

%{!?python_sitelib:  %define python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%{!?python_abi:      %define python_abi      %(%{__python} -c "import sys; print sys.version[:3]")}

%{!?ruby_sitelib:    %define ruby_sitelib    %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']"   2>/dev/null || echo 'None')}
%{!?ruby_sitearch:   %define ruby_sitearch   %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']"  2>/dev/null || echo 'None')}
%{!?ruby_abi:        %define ruby_abi        %(ruby -rrbconfig -e "puts Config::CONFIG['ruby_version']" 2>/dev/null || echo 'None')}

%{!?lua_sitelib:     %define lua_sitelib     %(pkg-config lua --variable="INSTALL_LMOD" 2>/dev/null || echo 'None')}
%{!?lua_sitearch:    %define lua_sitearch    %(pkg-config lua --variable="INSTALL_CMOD" 2>/dev/null || echo 'None')}
%{!?lua_abi:         %define lua_abi         %(pkg-config lua --variable="V"            2>/dev/null || echo 'None')}

%define pkg     prelude


Summary:        A library for using the Prelude framework
Name:           lib%{pkg}
Version:        0.9.24.1
Release:        1%{?dist}%{?pext}
License:        GPL
Group:          System Environment/Libraries
Source0:        http://www.prelude-ids.com/download/releases/%{name}/%{name}-%{version}.tar.gz
Patch0:         %{name}-0.9.24.1-python.patch
Patch1:         %{name}-0.9.24.1-lua.patch
URL:            http://www.prelude-ids.com/
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:         PreludeIDS Technologies
Requires:       %{pkg}-progs = %{version}-%{release}
BuildRequires:  gnutls-devel >= 1.0.17
BuildRequires:  libgcrypt-devel >= 1.1.94
BuildRequires:  perl(Config) perl(Cwd)
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(ExtUtils::MM_Unix)
BuildRequires:  perl(File::Copy)
BuildRequires:  python-devel python-setuptools
BuildRequires:  ruby ruby-devel
BuildRequires:  liblua-devel

%description
LibPrelude is a library that guarantees secure connections between all sensors
and the Prelude Manager. It provides an Application Programming Interface (API)
for the communication with Prelude sub-systems, supplies the necessary functions
for generating and emitting IDMEF events with Prelude and automates the saving
and re-transmission of data in times of temporary interruption of one of the
components of the system.


%package        devel
Summary:        Development tools for LibPrelude
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       gnutls-devel libgcrypt-devel pkgconfig

%description    devel
The %{name}-devel package contains the static libraries and header files for
developing software using LibPrelude.


%package     -n %{pkg}-progs
Summary:        Related programs for LibPrelude
Group:          Applications/Internet
Requires:       %{name} = %{version}-%{release}

%description -n %{pkg}-progs
The %{pkg}-progs package contains the management programs for LibPrelude.


%package     -n perl-%{pkg}
Summary:        Perl bindings for LibPrelude
Group:          Development/Libraries
Provides:       perl(Prelude) = %{version}
Requires:       %{name} = %{version}-%{release}
Requires:       perl(:MODULE_COMPAT_%{perl_version})

%description -n perl-%{pkg}
The perl-%{pkg} package contains the Perl bindings for LibPrelude.


%package     -n python-%{pkg}
Summary:        Python bindings for LibPrelude
Group:          Development/Languages
Provides:       python(PreludeEasy) = %{version}
Provides:       python(%{pkg}) = %{version}
Requires:       %{name} = %{version}-%{release}

%description -n python-%{pkg}
The python-%{pkg} package contains the python bindings for LibPrelude.


%package     -n ruby-%{pkg}
Summary:        Ruby bindings for LibPrelude
Group:          Development/Languages
Provides:       ruby(PreludeEasy) = %{version}
Requires:       %{name} = %{version}-%{release}
Requires:       ruby(abi) = %{ruby_abi}

%description -n ruby-%{pkg}
The ruby-%{pkg} package contains the Ruby bindings for LibPrelude.


%package     -n lua-%{pkg}
Summary:        Lua bindings for LibPrelude
Group:          Development/Languages
Provides:       lua(PreludeEasy) = %{version}
Requires:       %{name} = %{version}-%{release}
Requires:       lua(abi) = %{lua_abi}

%description -n lua-%{pkg}
The lua-%{pkg} package contains the Lua bindings for LibPrelude.


%prep
%setup -q
%patch0 -p1
%patch1 -p1


%build
BUILDFLAGS="-fno-strict-aliasing -Wno-unused"

%configure \
	CFLAGS="${RPM_OPT_FLAGS} ${BUILDFLAGS}"   \
	CXXFLAGS="${RPM_OPT_FLAGS} ${BUILDFLAGS}" \
	--enable-shared                           \
	--enable-static                           \
	--enable-easy-bindings                    \
	--with-perl                               \
	--with-perl-installdirs="vendor"          \
	--with-python

%{__make} %{?_smp_mflags}


%check
%{__make} check


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

# Perl bindings
find ${RPM_BUILD_ROOT}%{perl_archlib}    -type f -name "perl*.pod"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name ".packlist"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name "*.bs" -a -size 0 -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -depth  -empty -type d          -exec rmdir      {} \;

%{__chmod} -R u+w ${RPM_BUILD_ROOT}%{perl_vendorarch}/*

# Ruby/Lua bindings
%{__rm}    -f     ${RPM_BUILD_ROOT}%{ruby_sitearch}/PreludeEasy.*a
%{__rm}    -f     ${RPM_BUILD_ROOT}%{lua_sitearch}/PreludeEasy.*a

# Cleanup
%{__rm}    -f     ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.?
%{__rm}    -rf    ${RPM_BUILD_ROOT}%{_datadir}/gtk-doc


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog HACKING* INSTALL LICENSE* NEWS README
%{_libdir}/%{name}*.so.*

%files devel
%defattr(-,root,root)
%doc docs/api/html/*
%{_bindir}/%{name}-config
%{_includedir}/%{name}
%{_libdir}/%{name}*.*a
%{_libdir}/%{name}*.so
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/aclocal/%{name}.m4

%files -n %{pkg}-progs
%defattr(-,root,root)
%dir %{_sysconfdir}/%{pkg}
%config(noreplace) %{_sysconfdir}/%{pkg}/*
%{_bindir}/%{pkg}-adduser
%{_bindir}/%{pkg}-admin
%{_mandir}/man1/*.1*
%dir %{_localstatedir}/spool/%{pkg}

%files -n perl-%{pkg}
%defattr(-,root,root)
%{perl_vendorarch}/auto/Prelude
%{perl_vendorarch}/Prelude.pm

%files -n python-%{pkg}
%defattr(-,root,root)
%{python_sitearch}/PreludeEasy.py*
%{python_sitearch}/_PreludeEasy.so
%{python_sitearch}/_prelude.so
%{python_sitearch}/%{pkg}.py*
%{python_sitearch}/*.egg-info

%files -n ruby-%{pkg}
%defattr(-,root,root)
%{ruby_sitearch}/PreludeEasy.so

%files -n lua-%{pkg}
%defattr(-,root,root)
%{lua_sitearch}/PreludeEasy.so


%changelog
* Fri Aug 21 2009 Peter Pramberger <peterpramb@member.fsf.org> - 0.9.24.1-1
- Initial build
